diff --git a/drivers/iio/industrialio-buffer.c b/drivers/iio/industrialio-buffer.c
index aa2f46c0949f..c335484a6651 100644
--- a/drivers/iio/industrialio-buffer.c
+++ b/drivers/iio/industrialio-buffer.c
@@ -244,12 +244,13 @@ static int iio_buffer_chrdev_release(struct inode *inode, struct file *filp)
  */
 void iio_buffer_wakeup_poll(struct iio_dev *indio_dev)
 {
-	struct iio_buffer *buffer = indio_dev->buffer;
+	struct iio_buffer *b;
 
-	if (!buffer)
+	if (list_empty(&indio_dev->attached_buffers))
 		return;
 
-	wake_up(&buffer->pollq);
+	list_for_each_entry(b, &indio_dev->attached_buffers, attached_entry)
+		wake_up(&b->pollq);
 }
 
 void iio_buffer_init(struct iio_buffer *buffer)
@@ -1547,10 +1548,27 @@ static int iio_device_link_legacy_folders(struct iio_dev *indio_dev,
 	return ret;
 }
 
+static void __iio_device_buffers_cleanup(struct iio_dev *indio_dev, int idx)
+{
+	struct iio_buffer *b;
+
+	if (list_empty(&indio_dev->attached_buffers))
+		return;
+
+	list_for_each_entry(b, &indio_dev->attached_buffers, attached_entry) {
+		if (idx == 0)
+			break;
+
+		iio_device_buffer_cleanup(b);
+		if (idx > 0)
+			idx--;
+	}
+}
+
 int iio_device_buffers_init(struct iio_dev *indio_dev)
 {
-	struct iio_buffer *buffer = indio_dev->buffer;
 	const struct iio_chan_spec *channels;
+	struct iio_buffer *b;
 	int i, ret;
 
 	channels = indio_dev->channels;
@@ -1562,32 +1580,38 @@ int iio_device_buffers_init(struct iio_dev *indio_dev)
 		indio_dev->masklength = ml;
 	}
 
-	if (!buffer)
+	if (list_empty(&indio_dev->attached_buffers))
 		return 0;
 
-	ret = iio_device_buffer_init(indio_dev, buffer, 0);
-	if (ret)
-		return ret;
+	i = 0;
+	list_for_each_entry(b, &indio_dev->attached_buffers, attached_entry) {
+		ret = iio_device_buffer_init(indio_dev, b, i);
+		if (ret)
+			goto error_buffers_cleanup;
 
-	ret = iio_device_link_legacy_folders(indio_dev, buffer);
-	if (ret)
-		goto error_buffers_cleanup;
+		if (i == 0) {
+			ret = iio_device_link_legacy_folders(indio_dev, b);
+			if (ret) {
+				iio_device_buffer_cleanup(b);
+				goto error_buffers_cleanup;
+			}
+		}
+		i++;
+	}
 
 	return 0;
 
 error_buffers_cleanup:
-	iio_device_buffer_cleanup(buffer);
-	return 0;
+	__iio_device_buffers_cleanup(indio_dev, i);
+	return ret;
 }
 
 void iio_device_buffers_cleanup(struct iio_dev *indio_dev)
 {
-	struct iio_buffer *buffer = indio_dev->buffer;
-
 	sysfs_remove_link(&indio_dev->dev.kobj, "buffer");
 	sysfs_remove_link(&indio_dev->dev.kobj, "scan_elements");
 
-	iio_device_buffer_cleanup(buffer);
+	__iio_device_buffers_cleanup(indio_dev, -1);
 }
 
 static const struct file_operations iio_buffer_fileops = {
@@ -1615,12 +1639,13 @@ void iio_device_buffer_attach_chrdev(struct iio_dev *indio_dev)
 
 void iio_device_buffers_put(struct iio_dev *indio_dev)
 {
-	struct iio_buffer *buffer = indio_dev->buffer;
+	struct iio_buffer *b;
 
-	if (!buffer)
+	if (list_empty(&indio_dev->attached_buffers))
 		return;
 
-	iio_buffer_put(buffer);
+	list_for_each_entry(b, &indio_dev->attached_buffers, attached_entry)
+		iio_buffer_put(b);
 }
 
 /**
@@ -1733,7 +1758,7 @@ void iio_buffer_put(struct iio_buffer *buffer)
 EXPORT_SYMBOL_GPL(iio_buffer_put);
 
 /**
- * iio_device_attach_buffer - Attach a buffer to a IIO device
+ * iio_device_attach_buffer_dir - Attach a buffer to a IIO device direction
  * @indio_dev: The device the buffer should be attached to
  * @buffer: The buffer to attach to the device
  *
@@ -1744,8 +1769,13 @@ EXPORT_SYMBOL_GPL(iio_buffer_put);
 void iio_device_attach_buffer(struct iio_dev *indio_dev,
 			      struct iio_buffer *buffer)
 {
-	indio_dev->buffer = iio_buffer_get(buffer);
+	buffer = iio_buffer_get(buffer);
+	buffer->indio_dev = indio_dev;
+
+	/* keep this for legacy */
+	if (!indio_dev->buffer)
+		indio_dev->buffer = buffer;
 
-	indio_dev->buffer->indio_dev = indio_dev;
+	list_add_tail(&buffer->attached_entry, &indio_dev->attached_buffers);
 }
 EXPORT_SYMBOL_GPL(iio_device_attach_buffer);
diff --git a/drivers/iio/industrialio-core.c b/drivers/iio/industrialio-core.c
index b27fabf13e9c..067e5de76b6c 100644
--- a/drivers/iio/industrialio-core.c
+++ b/drivers/iio/industrialio-core.c
@@ -1534,6 +1534,7 @@ struct iio_dev *iio_device_alloc(int sizeof_priv)
 	}
 	dev_set_name(&dev->dev, "iio:device%d", dev->id);
 	INIT_LIST_HEAD(&dev->buffer_list);
+	INIT_LIST_HEAD(&dev->attached_buffers);
 	INIT_LIST_HEAD(&dev->ioctl_handlers);
 
 	return dev;
diff --git a/include/linux/iio/buffer_impl.h b/include/linux/iio/buffer_impl.h
index e8203b6d51a1..9ee3a7c0a657 100644
--- a/include/linux/iio/buffer_impl.h
+++ b/include/linux/iio/buffer_impl.h
@@ -130,6 +130,9 @@ struct iio_buffer {
 	/* @demux_bounce: Buffer for doing gather from incoming scan. */
 	void *demux_bounce;
 
+	/* @attached_buffers: Entry in the devices list of attached buffers. */
+	struct list_head attached_entry;
+
 	/* @buffer_list: Entry in the devices list of current buffers. */
 	struct list_head buffer_list;
 
diff --git a/include/linux/iio/iio.h b/include/linux/iio/iio.h
index 671f5818fa67..32ba1a303454 100644
--- a/include/linux/iio/iio.h
+++ b/include/linux/iio/iio.h
@@ -492,6 +492,7 @@ struct iio_buffer_setup_ops {
  * @event_interface:	[INTERN] event chrdevs associated with interrupt lines
  * @buffer:		[DRIVER] any buffer present
  * @buffer_list:	[INTERN] list of all buffers currently attached
+ * @attached_buffers:	[INTERN] list of all attached buffers
  * @scan_bytes:		[INTERN] num bytes captured to be fed to buffer demux
  * @mlock:		[INTERN] lock used to prevent simultaneous device state
  *			changes
@@ -536,6 +537,7 @@ struct iio_dev {
 
 	struct iio_buffer		*buffer;
 	struct list_head		buffer_list;
+	struct list_head		attached_buffers;
 	int				scan_bytes;
 	struct mutex			mlock;
 